#ifndef ATTRIBUTEINFO_HPP
#define ATTRIBUTEINFO_HPP ATTRIBUTEINFO_HPP

#include <stddef.h>
#include <sys/types.h>

#include <iostream>

using namespace std;

class AttributeInfo {
private:
  u_int16_t attribute_name_index;
  u_int32_t attribute_length;
  u_int8_t* info;

protected:
  void setAttributeNameIndex(const u_int16_t&);
  void setData(const u_int32_t&, const u_int8_t*);

public:
  const static string Code;
  const static string SourceFile;
  const static string LineNumberTable;
  const static string ConstantValue;
  const static string Exceptions;
  const static string InnerClasses;
  const static string Synthetic;
  const static string LocalVariableTable;
  const static string Deprecated;

  AttributeInfo(const u_int16_t& ani = 0,
                const u_int32_t& l = 0,
                u_int8_t* i = NULL);
  virtual ~AttributeInfo();

  const u_int16_t& getAttributeNameIndex() const;
  const u_int32_t& getAttributeLength() const;

  virtual ostream& toOStream(ostream&) const;
  virtual ostream& toOStreamAsHTML(ostream&) const;
};

ostream& operator<<(ostream&, const AttributeInfo&);

#endif
