#ifndef CPINFO_HPP
#define CPINFO_HPP CPINFO_HPP

#include <sys/types.h>

#include <iostream>

using namespace std;

class CPInfo {
public:
  enum Tag {
    CONSTANT_Utf8                = 1,
    CONSTANT_Integer             = 3,
    CONSTANT_Float               = 4,
    CONSTANT_Long                = 5,
    CONSTANT_Double              = 6,
    CONSTANT_Class               = 7,
    CONSTANT_String              = 8,
    CONSTANT_Fieldref            = 9,
    CONSTANT_Methodref           = 10,
    CONSTANT_InterfaceMethodref  = 11,
    CONSTANT_NameAndType         = 12
  };

private:
  Tag tag;
  u_int16_t length;
  u_int8_t* info;

protected:
  void setTag(const Tag&);
  void setData(const u_int16_t&, const u_int8_t*);

public:
  CPInfo(const Tag& t = CONSTANT_Utf8,
         const u_int16_t& l = 0,
         u_int8_t* i = 0);
  virtual ~CPInfo();

  const Tag& getTag() const;
  const u_int16_t& getLength() const;
  const u_int8_t* getInfo() const;
  
  virtual ostream& toOStream(ostream&) const;
  virtual ostream& toOStreamAsHTML(ostream&) const;
};

ostream& operator<<(ostream&, const CPInfo::Tag&);

ostream& operator<<(ostream&, const CPInfo&);

#endif
