#ifndef CLASSLOADER_HPP
#define CLASSLOADER_HPP CLASSLOADER_HPP

#include "ByteClass.hpp"

#include <string>
#include <fstream>
#include <map>
#include <list>
#include <vector>

#include <inttypes.h>

using namespace std;

class ClassLoader {
private:
  string filename;
  ifstream input;

  void read(u_int8_t&);
  void read(u_int16_t&);
  void read(u_int32_t&);
  void read(u_int64_t&);
  void printConstantPoolInfo(const u_int16_t&) const;
  void printAccessFlags(const u_int16_t&) const;
  void open();
  void checkHeader();
  CPInfo* parseCPInfo(bool&);
  AttributeInfo* parseAttributeInfo(const vector<CPInfo*>&);
  FieldInfo* parseFieldInfo(const vector<CPInfo*>&);
  MethodInfo* parseMethodInfo(const vector<CPInfo*>&);

public:
  ClassLoader();
  ~ClassLoader();

  ByteClass* load(const string& path);

};

#endif
