#include "ConstClassInfo.hpp"

#include "ByteClass.hpp"

ConstClassInfo::ConstClassInfo(const u_int16_t& ni)
  : CPInfo(CPInfo::CONSTANT_Class),
    name_index(ni) {
  u_int8_t cpinfo_info[2];
  cpinfo_info[0] = (u_int8_t) (0x00FF & name_index);
  cpinfo_info[1] = (u_int8_t) (name_index >> 8);
  setData(2, cpinfo_info);
}

ConstClassInfo::~ConstClassInfo() {

}

const u_int16_t& ConstClassInfo::getNameIndex() const {
  return name_index;
}

ostream& ConstClassInfo::toOStream(ostream& os) const {
  CPInfo::toOStream(os);

  os << "\t\tidx(" << name_index << ")";

  return os;
}

ostream& ConstClassInfo::toOStreamAsHTML(ostream& os) const {
  os << "<li>ConstClassInfo: idx(";
  ByteClass::referenceTo(os, name_index, "ConstantPool");
  os << ")</li>" << endl;

  return os;
}

