#include "ConstDoubleInfo.hpp"

ConstDoubleInfo::ConstDoubleInfo(const u_int64_t& double_as_integer)
  : CPInfo(CPInfo::CONSTANT_Double),
    double_data(0) {
  u_int8_t cpinfo_info[8];
  cpinfo_info[0] = (u_int8_t) (0xFF & double_as_integer);
  cpinfo_info[1] = (u_int8_t) (0xFF & (double_as_integer >> 8));
  cpinfo_info[2] = (u_int8_t) (0xFF & (double_as_integer >> 16));
  cpinfo_info[3] = (u_int8_t) (0xFF & (double_as_integer >> 24));
  cpinfo_info[4] = (u_int8_t) (0xFF & (double_as_integer >> 32));
  cpinfo_info[5] = (u_int8_t) (0xFF & (double_as_integer >> 40));
  cpinfo_info[6] = (u_int8_t) (0xFF & (double_as_integer >> 48));
  cpinfo_info[7] = (u_int8_t) (0xFF & (double_as_integer >> 56));
  setData(8, cpinfo_info);
  // on x86 archs, the bytecode representation of doubles can be
  // converted to real double with memcpy (after converting from BE to
  // LE!)
  memcpy(&double_data, &double_as_integer, sizeof(double));
}

ConstDoubleInfo::~ConstDoubleInfo() {

}

ostream& ConstDoubleInfo::toOStream(ostream& os) const {
  CPInfo::toOStream(os);

  os << "\t\tdouble(" << double_data << ")";

  return os;
}

ostream& ConstDoubleInfo::toOStreamAsHTML(ostream& os) const {
  os << "<li>ConstDoubleInfo: double(" << double_data << ")</li>" << endl;

  return os;
}

