#include "ConstFieldInfo.hpp"

#include "ByteClass.hpp"

ConstFieldInfo::ConstFieldInfo(const u_int16_t& ci, const u_int16_t& nti)
  : CPInfo(CPInfo::CONSTANT_Fieldref),
    class_index(ci),
    name_and_type_index(nti) {
  u_int8_t cpinfo_info[4];
  cpinfo_info[0] = (u_int8_t) (0x00FF & class_index);
  cpinfo_info[1] = (u_int8_t) (class_index >> 8);
  cpinfo_info[2] = (u_int8_t) (0x00FF & name_and_type_index);
  cpinfo_info[3] = (u_int8_t) (name_and_type_index >> 8);
  setData(4, cpinfo_info);
}

ConstFieldInfo::~ConstFieldInfo() {

}

ostream& ConstFieldInfo::toOStream(ostream& os) const {
  CPInfo::toOStream(os);

  os << "\t\tclass_idx(" << class_index << ") name_&_type_idx(" << name_and_type_index << ")";

  return os;
}

ostream& ConstFieldInfo::toOStreamAsHTML(ostream& os) const {
  os << "<li>ConstFieldInfo:</li>" << endl
     << "<ul>" << endl
     << "<li>class_idx(";
  ByteClass::referenceTo(os, class_index, "ConstantPool");
  os << ")</li>" << endl
     << "<li>name_and_type_idx(";
  ByteClass::referenceTo(os, name_and_type_index, "ConstantPool");
  os << ")</li>" << endl
     << "</ul>" << endl;

  return os;
}

