#include "ConstFloatInfo.hpp"

ConstFloatInfo::ConstFloatInfo(const u_int32_t& float_as_integer)
  : CPInfo(CPInfo::CONSTANT_Float),
    float_data(0) {
  u_int8_t cpinfo_info[4];
  cpinfo_info[0] = (u_int8_t) (0x000000FF & float_as_integer);
  cpinfo_info[1] = (u_int8_t) (0x000000FF & (float_as_integer >> 8));
  cpinfo_info[2] = (u_int8_t) (0x000000FF & (float_as_integer >> 16));
  cpinfo_info[3] = (u_int8_t) (0x000000FF & (float_as_integer >> 24));
  setData(4, cpinfo_info);
  // on x86 archs, the bytecode representation of floats can be
  // converted to real float with memcpy (after converting from BE to
  // LE!)
  memcpy(&float_data, &float_as_integer, sizeof(float));
}

ConstFloatInfo::~ConstFloatInfo() {

}

ostream& ConstFloatInfo::toOStream(ostream& os) const {
  CPInfo::toOStream(os);

  os << "\t\tfloat(" << float_data << ")";

  return os;
}

ostream& ConstFloatInfo::toOStreamAsHTML(ostream& os) const {
  os << "<li>ConstFloatInfo: float(" << float_data << ")</li>" << endl;

  return os;
}

