#include "ConstIntegerInfo.hpp"

ConstIntegerInfo::ConstIntegerInfo(const u_int32_t& i)
  : CPInfo(CPInfo::CONSTANT_Integer),
    integer(i) {
  u_int8_t cpinfo_info[4];
  cpinfo_info[0] = (u_int8_t) (0x000000FF & integer);
  cpinfo_info[1] = (u_int8_t) (0x000000FF & (integer >> 8));
  cpinfo_info[2] = (u_int8_t) (0x000000FF & (integer >> 16));
  cpinfo_info[3] = (u_int8_t) (0x000000FF & (integer >> 24));
  setData(4, cpinfo_info);
}

ConstIntegerInfo::~ConstIntegerInfo() {

}

ostream& ConstIntegerInfo::toOStream(ostream& os) const {
  CPInfo::toOStream(os);

  os << "\t\tint(" << integer << ")";

  return os;
}

ostream& ConstIntegerInfo::toOStreamAsHTML(ostream& os) const {
  os << "<li>ConstIntegerInfo: int(" << integer << ")</li>" << endl;

  return os;
}

