#include "ConstLongInfo.hpp"

ConstLongInfo::ConstLongInfo(const u_int64_t& l)
  : CPInfo(CPInfo::CONSTANT_Long),
    long_integer(l) {
  u_int8_t cpinfo_info[8];
  cpinfo_info[0] = (u_int8_t) (0xFF & long_integer);
  cpinfo_info[1] = (u_int8_t) (0xFF & (long_integer >> 8));
  cpinfo_info[2] = (u_int8_t) (0xFF & (long_integer >> 16));
  cpinfo_info[3] = (u_int8_t) (0xFF & (long_integer >> 24));
  cpinfo_info[4] = (u_int8_t) (0xFF & (long_integer >> 32));
  cpinfo_info[5] = (u_int8_t) (0xFF & (long_integer >> 40));
  cpinfo_info[6] = (u_int8_t) (0xFF & (long_integer >> 48));
  cpinfo_info[7] = (u_int8_t) (0xFF & (long_integer >> 56));
  setData(8, cpinfo_info);
}

ConstLongInfo::~ConstLongInfo() {

}

ostream& ConstLongInfo::toOStream(ostream& os) const {
  CPInfo::toOStream(os);

  os << "\t\tlong(" << long_integer << ")";

  return os;
}

ostream& ConstLongInfo::toOStreamAsHTML(ostream& os) const {
  os << "<li>ConstLongInfo: long(" << long_integer << ")</li>" << endl;

  return os;
}

