#include "ConstNameAndTypeInfo.hpp"

#include "ByteClass.hpp"

ConstNameAndTypeInfo::ConstNameAndTypeInfo(const u_int16_t& ni, const u_int16_t& di)
  : CPInfo(CPInfo::CONSTANT_NameAndType),
    name_index(ni),
    descriptor_index(di) {
  u_int8_t cpinfo_info[4];
  cpinfo_info[0] = (u_int8_t) (0x00FF & name_index);
  cpinfo_info[1] = (u_int8_t) (name_index >> 8);
  cpinfo_info[2] = (u_int8_t) (0x00FF & descriptor_index);
  cpinfo_info[3] = (u_int8_t) (descriptor_index >> 8);
  setData(4, cpinfo_info);
}

ConstNameAndTypeInfo::~ConstNameAndTypeInfo() {

}

ostream& ConstNameAndTypeInfo::toOStream(ostream& os) const {
  CPInfo::toOStream(os);

  os << "\tname_idx(" << name_index << ") descriptor_idx(" << descriptor_index << ")";

  return os;
}

ostream& ConstNameAndTypeInfo::toOStreamAsHTML(ostream& os) const {
  os << "<li>ConstNameAndTypeInfo:</li>" << endl
     << "<ul>" << endl
     << "<li>name_idx(";
  ByteClass::referenceTo(os, name_index, "ConstantPool");
  os << ")</li>" << endl
     << "<li>descriptor_idx(";
  ByteClass::referenceTo(os, descriptor_index, "ConstantPool");
  os << ")</li>" << endl
     << "</ul>" << endl;

  return os;
}

