#include "ConstStringInfo.hpp"

#include "ByteClass.hpp"

ConstStringInfo::ConstStringInfo(const u_int16_t& si)
  : CPInfo(CPInfo::CONSTANT_String),
    string_index(si) {
  u_int8_t cpinfo_info[2];
  cpinfo_info[0] = (u_int8_t) (0x00FF & string_index);
  cpinfo_info[1] = (u_int8_t) (string_index >> 8);
  setData(2, cpinfo_info);
}

ConstStringInfo::~ConstStringInfo() {

}

ostream& ConstStringInfo::toOStream(ostream& os) const {
  CPInfo::toOStream(os);

  os << "\t\tidx(" << string_index << ")";

  return os;
}

ostream& ConstStringInfo::toOStreamAsHTML(ostream& os) const {
  os << "<li>ConstStringInfo: idx(";
  ByteClass::referenceTo(os, string_index, "ConstantPool");
  os << ")</li>" << endl;

  return os;
}

