#include "ConstUtf8Info.hpp"

#include "JavaString.hpp"

ConstUtf8Info::ConstUtf8Info(const u_int16_t& l /*= 0*/,
                             u_int8_t* i /*= 0*/)
  : CPInfo(CPInfo::CONSTANT_Utf8, l, i),
    java_string(JavaString::fromUTF8(i, l)) {
}

ConstUtf8Info::~ConstUtf8Info() {

}

const JavaString& ConstUtf8Info::getString() const {
  return java_string;
}

ostream& ConstUtf8Info::toOStream(ostream& os) const {
  CPInfo::toOStream(os);

  os << "\t\t\"" << java_string << "\"";

  return os;
}

ostream& ConstUtf8Info::toOStreamAsHTML(ostream& os) const {
  string html_java_string(java_string.toSTLString());

  os << "<li>ConstUtf8Info: \"";
  for (unsigned int i = 0; i < html_java_string.size(); i++) {
    if (html_java_string[i] == '<') {
      os << "&lt;";
    } else {
      os << html_java_string[i];
    }
  }
  os << "\"</li>" << endl;

  return os;
}

