#include "ConstantValueAttribute.hpp"

#include "ByteClass.hpp"

ConstantValueAttribute::ConstantValueAttribute(const u_int16_t& index, const u_int16_t& cvi)
  : AttributeInfo(index, 2),
    constantvalue_index(cvi) {
  u_int8_t attributeinfo_info[2];
  attributeinfo_info[0] = (u_int8_t) (0x00FF & constantvalue_index);
  attributeinfo_info[1] = (u_int8_t) (constantvalue_index >> 8);
  setData(2, attributeinfo_info);
}

ConstantValueAttribute::~ConstantValueAttribute() {

}

const u_int16_t& ConstantValueAttribute::getConstantValueIndex() const {
  return constantvalue_index;
}

ostream& ConstantValueAttribute::toOStream(ostream& os) const {
  os << "ConstantValue:\tidx(" << constantvalue_index << ")";

  return os;
}

ostream& ConstantValueAttribute::toOStreamAsHTML(ostream& os) const {
  os << "<li>ConstantValue: idx(";
  ByteClass::referenceTo(os, constantvalue_index, "ConstantPool");
  os << ")</li>" << endl;

  return os;
}

