#ifndef EXCEPTIONSATTRIBUTE_HPP
#define EXCEPTIONSATTRIBUTE_HPP EXCEPTIONSATTRIBUTE_HPP

#include "AttributeInfo.hpp"

#include <vector>

using namespace std;

class ExceptionsAttribute
  : public AttributeInfo {
private:
  friend class ClassLoader;

  vector<u_int16_t> exception_index_table;

public:
  ExceptionsAttribute(const u_int16_t& index = 0);
  virtual ~ExceptionsAttribute();

  u_int16_t getNumberOfExceptions() const;
  const u_int16_t& getExceptionIndexTable(const u_int16_t&) const;
  
  virtual ostream& toOStream(ostream&) const;
  virtual ostream& toOStreamAsHTML(ostream&) const;
};

#endif
