#ifndef FIELDINFO_HPP
#define FIELDINFO_HPP FIELDINFO_HPP

#include "AttributeInfo.hpp"

#include <sys/types.h>

#include <vector>
#include <iostream>

using namespace std;

class ClassLoader;

class FieldInfo {
private:
  friend class ClassLoader;

  u_int16_t access_flags;
  u_int16_t name_index;
  u_int16_t descriptor_index;
  u_int16_t attributes_count;
  vector<AttributeInfo*> attributes;

public:
  FieldInfo(const u_int16_t& af = 0,
            const u_int16_t& ni = 0,
            const u_int16_t& di = 0,
            const u_int16_t& ac = 0);
  virtual ~FieldInfo();

  const u_int16_t& getAccessFlags() const;
  const u_int16_t& getNameIndex() const;
  const u_int16_t& getDescriptorIndex() const;
  const u_int16_t& getAttributesCount() const;
  const AttributeInfo& getAttribute(const u_int16_t&) const;

  virtual ostream& toOStream(ostream&) const;
  virtual ostream& toOStreamAsHTML(ostream&) const;
};

ostream& operator<<(ostream&, const FieldInfo&);

#endif
