#ifndef INNERCLASSESATTRIBUTE_HPP
#define INNERCLASSESATTRIBUTE_HPP INNERCLASSESATTRIBUTE_HPP

#include "AttributeInfo.hpp"

#include <vector>

using namespace std;

class InnerClassesAttribute
  : public AttributeInfo {
private:
  friend class ClassLoader;

  vector<u_int16_t> inner_classes_index_table;

public:
  InnerClassesAttribute(const u_int16_t& index = 0);
  virtual ~InnerClassesAttribute();

  u_int16_t getNumberOfInnerClasses() const;
  const u_int16_t& getInnerClassesIndexTable(const u_int16_t&) const;
  
  virtual ostream& toOStream(ostream&) const;
  virtual ostream& toOStreamAsHTML(ostream&) const;
};

#endif
