#ifndef LINENUMBERTABLEATTRIBUTE_HPP
#define LINENUMBERTABLEATTRIBUTE_HPP LINENUMBERTABLEATTRIBUTE_HPP

#include "AttributeInfo.hpp"

#include <vector>

using namespace std;

class LineNumberTableAttribute
  : public AttributeInfo {
public:
  class LineNumberTable {
  private:
    u_int16_t start_pc;
    u_int16_t line_number;

  public:
    LineNumberTable(const u_int16_t& start = 0,
                    const u_int16_t& line = 0)
      : start_pc(start),
        line_number(line) {
    }

    const u_int16_t& getStartPC()    const { return start_pc;    }
    const u_int16_t& getLineNumber() const { return line_number; }
  };

private:
  friend class ClassLoader;

  vector<LineNumberTable*> line_number_table;

public:
  LineNumberTableAttribute(const u_int16_t& index = 0);
  virtual ~LineNumberTableAttribute();

  u_int16_t getLineNumberTableLength() const;
  const LineNumberTable& getLineNumberTable(const u_int16_t&) const;
  
  virtual ostream& toOStream(ostream&) const;
  virtual ostream& toOStreamAsHTML(ostream&) const;
};

#endif
