#ifndef LOCALVARIABLETABLEATTRIBUTE_HPP
#define LOCALVARIABLETABLEATTRIBUTE_HPP LOCALVARIABLETABLEATTRIBUTE_HPP

#include "AttributeInfo.hpp"

#include <vector>

using namespace std;

class LocalVariableTableAttribute
  : public AttributeInfo {
public:
  class LocalVariableTable {
  private:
    u_int16_t start_pc;
    u_int16_t length;
    u_int16_t name_index;
    u_int16_t descriptor_index;
    u_int16_t index;

  public:
    LocalVariableTable(const u_int16_t& start = 0,
                       const u_int16_t& l = 0,
                       const u_int16_t& ni = 0,
                       const u_int16_t& di = 0,
                       const u_int16_t& idx = 0)
      : start_pc(start),
        length(l),
        name_index(ni),
        descriptor_index(di),
        index(idx) {
    }

    const u_int16_t& getStartPC()    const { return start_pc;    }
    const u_int16_t& getLength() const { return length; }
    const u_int16_t& getNameIndex() const { return name_index; }
    const u_int16_t& getDescriptorIndex() const { return descriptor_index; }
    const u_int16_t& getIndex() const { return index; }
  };

private:
  friend class ClassLoader;

  vector<LocalVariableTable*> local_variable_table;

public:
  LocalVariableTableAttribute(const u_int16_t& index = 0);
  virtual ~LocalVariableTableAttribute();

  u_int16_t getLocalVariableTableLength() const;
  const LocalVariableTable& getLocalVariableTable(const u_int16_t&) const;
  
  virtual ostream& toOStream(ostream&) const;
  virtual ostream& toOStreamAsHTML(ostream&) const;
};

#endif
