#include "SourceFileAttribute.hpp"

#include "ByteClass.hpp"

SourceFileAttribute::SourceFileAttribute(const u_int16_t& index, const u_int16_t& sfi)
  : AttributeInfo(index, 2),
    sourcefile_index(sfi) {
  u_int8_t attributeinfo_info[2];
  attributeinfo_info[0] = (u_int8_t) (0x00FF & sourcefile_index);
  attributeinfo_info[1] = (u_int8_t) (sourcefile_index >> 8);
  setData(2, attributeinfo_info);
}

SourceFileAttribute::~SourceFileAttribute() {

}

const u_int16_t& SourceFileAttribute::getSourceFileIndex() const {
  return sourcefile_index;
}

ostream& SourceFileAttribute::toOStream(ostream& os) const {
  os << "SourceFile:\tidx(" << sourcefile_index << ")";

  return os;
}

ostream& SourceFileAttribute::toOStreamAsHTML(ostream& os) const {
  os << "<li>SourceFile: idx(";
  ByteClass::referenceTo(os, sourcefile_index, "ConstantPool");
  os << ")</li>" << endl;

  return os;
}

