#ifndef INTCONVERT_H
#define INTCONVERT_H INTCONVERT_H

#include <inttypes.h>
#include <sys/types.h>

#ifdef __cplusplus
extern "C" {
#endif

static inline int64_t swap64(int64_t x){
  return((((u_int64_t)x & 0x00000000000000ffULL) << 56) | 
	 (((u_int64_t)x & 0x000000000000ff00ULL) << 40) | 
	 (((u_int64_t)x & 0x0000000000ff0000ULL) << 24) | 
	 (((u_int64_t)x & 0x00000000ff000000ULL) <<  8) |
         (((u_int64_t)x & 0x000000ff00000000ULL) >>  8) | 
	 (((u_int64_t)x & 0x0000ff0000000000ULL) >> 24) | 
	 (((u_int64_t)x & 0x00ff000000000000ULL) >> 40) | 
	 (((u_int64_t)x & 0xff00000000000000ULL) >> 56));
}

static inline int32_t swap32(int32_t x){
  return((((u_int32_t)x & 0x000000ffU) << 24) | 
	 (((u_int32_t)x & 0x0000ff00U) <<  8) | 
	 (((u_int32_t)x & 0x00ff0000U) >>  8) | 
	 (((u_int32_t)x & 0xff000000U) >> 24));
}

static inline int16_t swap16(int16_t x){
  return((((u_int16_t)x & 0x00ffU) <<  8) | 
	 (((u_int16_t)x & 0xff00U) >>  8));
}

static inline int64_t be64_to_cpu(int64_t x){
  return(swap64(x));
}

static inline int32_t be32_to_cpu(int32_t x){
  return(swap32(x));
}

static inline int16_t be16_to_cpu(int16_t x){
  return(swap16(x));
}

static inline int32_t le32_to_cpu(int32_t x){
  return(x);
}

static inline int16_t le16_to_cpu(int16_t x){
  return(x);
}

static inline int32_t cpu_to_be32(int32_t x){
  return(be32_to_cpu(x));
}

static inline int32_t cpu_to_le32(int32_t x){
  return(le32_to_cpu(x));
}

static inline int16_t cpu_to_be16(int16_t x){
  return(be16_to_cpu(x));
}

static inline int16_t cpu_to_le16(int16_t x){
  return(le16_to_cpu(x));
}

#ifdef __cplusplus
}
#endif

#endif
